'*******************************************************************************
'Display Driver IC ILI9341 320x240 Pixel
'
'Modus 8Bit
'
'Landscape and Portrait
'
'Bascom version 2.0.7.9
'Date 01.05.2015
'
'Autor: Hkipnik@aol.com
'
'Copyright by Hkipnik@aol.com
'
'
' der RD Pin vom Display an 3,3V legen
' RD Pin pull it high to 3,3V
'
' Hardware: Buy Display ER-TFTM024-3 2,4  2,8 inch TFT LCD Display Module
'           Buy Display ER-TFTM028-3 2,8
'           Buy Display ER-TFTM032-3 3,2
'
'
'*******************************************************************************
$regfile = "m2560def.dat"
$crystal = 16000000
$hwstack = 150
$swstack = 150
$framesize = 150

Config Submode = New
Const False = 0
Const True = 1
Config Com1 = 38400 , Synchrone = 0 , Parity = None , Stopbits = 1 , Databits = 8 , Clockpol = 0


'*******************************************************************************
'Display Mode
'*******************************************************************************
Const Use_touch = 0       'with Touch = 1 -- without Touch = 0
Const Touch_calibrate = 0       'Calibrate Touch 1=yes 0=no  only LCD_mode=1
Const Sd_card = 1       'with SD Card = 1 -- without SD Card = 0
Const Lcd_mode = 3       '1=Portrait 2=Portrait 180 3=landscape 4=landscape 180
'*******************************************************************************
' Declare Subs Variables Constants and Hardware Ports
'*******************************************************************************
$include "TFTDriver\ILI9341_declarations8.inc"

'*******************************************************************************
'Init SD Card
'*******************************************************************************
#if Sd_card = 1
   #if Use_touch = 0
   'wenn Touch nicht genutzt wird
      Config Porte.3 = Output       'CS vom Touch auf high legen
      Porte.3 = 1       'Touch und SD Card hngen am gleichen SPI port
   #endif
   $include "Avr-Dos\Config_MMCSD_HC.bas"
   $include "Avr-Dos\Config_AVR-DOS.bas"


#endif

'*******************************************************************************
'Init the Display
'*******************************************************************************
Lcd_init
Lcd_clear Black

'*******************************************************************************
' Touch Abgleich:
' Touch_calibrat ruft eine Sub auf die das Touch berechnet
' und die Abgleich Daten ins EEprom schreibt.Wenn der Touch sauber luft
' kann die Constante Touch_calibrate auf 0 gesetzt werden und bei jedem Neustart werden
' die Touch Werte aus dem Eeprom ausgelesen.
' Wichtig ist noch das Fuse Bit EEsave zu setzen, sonst wird das Eeprom bei jeden Flachen gelscht.
'*******************************************************************************

#if Use_touch = 1
   Enable Interrupts
   Read_touch_raw       'INIT Touch Controler

   #if Touch_calibrate = 1
      Touch_calibrat       'Touch Abgleich EESAVE Bit mu gesetzt sein
   #else       'Touch Abgleich Daten aus dem Eeprom auslesen
      X_offset = Xo       'z.B. 172
      Y_offset = Yo       '315
      X_fact = Xf       '15.52
      Y_fact = Yf       '11.22
      Xrotate = Xrotatee
      Yrotate = Yrotatee
   #endif
#endif


'*******************************************************************************
' Use for Demo
Dim Temp_str As String * 20
Dim Help_str As String * 10
Dim Dumb As Word
Dim Zahler As Byte
'*******************************************************************************
' SD Card Info
'*******************************************************************************
   Do
#if Sd_card = 1
   Init_sd_card       'Init SD Card
   Temp_str = "SD Card= " + Str(sd_ok)
   Lcd_text Temp_str , 1 , 1 , 2 , Yellow , Black , 1
'   1 OK
'   0 Error
   Temp_str = "SD Card Typ= " + Str(mmcsd_cardtype)
   Lcd_text Temp_str , 1 , 20 , 2 , Yellow , Black , 1
'   0 can't init the Card
'   1 MMC
'   2 SDSC Spec. 1.x
'   4 SDSC Spec. 2.0 or later
'  12 SDHC Spec. 2.0 or later

   Wait 2
   Lcd_clear Black
#endif


   Lcd_pic_binsd "earth.bin" , 0 , 0 , 240 , 320
   Wait 2
   Lcd_clear Red

   Lcd_draw_bmp "earth.bmp" , 0 , 0
   Wait 2

   Loop
'*******************************************************************************

Do
'*******************************************************************************
'*******************************************************************************
'     Portrait Mode
'*******************************************************************************
'*******************************************************************************
#if Lcd_mode = 1 Or Lcd_mode = 2
   Lcd_clear Black
   Lcd_text "Hallo World" , 10 , 50 , 2 , Red , White , 1

   Restore Pic2
   Lcd_pic_sram 82 , 110 , 75 , 102

   Wait 1
   Lcd_clear Black
'-------------------------------------------------------------------------------
      #if Use_touch = 1
         Touch_flag = 0
         Lcd_box 180 , 290 , 40 , 25 , 2 , Blue , Red
         Do
            If Touch_flag = 1 Then
               Lcd_read_touch


               Lcd_fill_circle Touchx , Touchy , 2 , Yellow

               Touch_flag = 0

               Help_str = Str(touchx)
               Temp_str = "X "
               Temp_str = Temp_str + Format(help_str , "0000")
               Lcd_text Temp_str , 10 , 1 , 2 , Yellow , Black , 1

               Help_str = Str(touchy)
               Temp_str = "Y "
               Temp_str = Temp_str + Format(help_str , "0000")
               Lcd_text Temp_str , 110 , 1 , 2 , Yellow , Black , 1


               If Touchx > 180 And Touchx < 220 Then
                  If Touchy > 290 And Touchy < 315 Then
                     Touch_flag = 0
                     Exit Do
                  End If
               End If
            End If
         Loop
         Lcd_clear Black
      #endif
'-------------------------------------------------------------------------------
 #if Sd_card = 1
   Lcd_pic_binsd "earth.bin" , 0 , 0 , 240 , 320
   Wait 2
   Lcd_clear Red

   Lcd_draw_bmp "earth.bmp" , 0 , 0
   Wait 2
 #endif
   Lcd_clear Black
   Lcd_text "Box with Border" , 10 , 10 , 2 , Blue , White , 1
   Lcd_box 10 , 50 , 220 , 220 , 2 , Red , Cyan
   Wait 1
   Lcd_clear Black
   Lcd_text "Box" , 10 , 10 , 2 , Blue , White , 1
   Lcd_box 10 , 50 , 210 , 210 , 1 , Red , Cyan
   Wait 1
   Lcd_clear Black
   Lcd_text "Box" , 10 , 10 , 2 , Blue , White , 1
   Lcd_box 10 , 50 , 200 , 200 , 3 , Red , Cyan

   Wait 3
   Lcd_clear Black
   Lcd_text "Circle" , 10 , 50 , 2 , Blue , White , 1
   Lcd_circle 100 , 100 , 20 , Yellow
   Lcd_circle 100 , 200 , 20 , Yellow
   Wait 1
   Lcd_clear Black
   Lcd_line 1 , 100 , 239 , 100 , 1 , Blue
   Lcd_line 1 , 130 , 239 , 130 , 2 , Red

   Lcd_line 120 , 1 , 120 , 319 , 2 , Red
   Lcd_line 1 , 1 , 239 , 319 , 2 , Yellow
   Lcd_line 239 , 1 , 1 , 319 , 2 , Green
   Wait 1
   Lcd_clear Blue
   Lcd_text "BGC Files" , 10 , 10 , 2 , Blue , Red , 1
    Restore Miky1
    Lcd_show_bgc 20 , 30
    Restore Miky1
    Lcd_show_bgc 20 , 180
    Wait 2     '
#endif
'*******************************************************************************
'*******************************************************************************
'*******************************************************************************
'     Landscape Mode
'*******************************************************************************
'*******************************************************************************
#if Lcd_mode = 3 Or Lcd_mode = 4
   Lcd_clear Black
   Lcd_text "Hello World" , 30 , 20 , 2 , Blue , Black , 2
   Lcd_text "ILI9341 Display 320x240" , 20 , 70 , 2 , Yellow , Black , 1

'   Restore Pic2
   Lcd_pic_sram 122 , 110 , 75 , 102

   Lcd_line 0 , 0 , 319 , 0 , 2 , Red
   Lcd_line 0 , 238 , 319 , 238 , 2 , Red
   Lcd_line 0 , 0 , 0 , 239 , 2 , Red
   Lcd_line 318 , 0 , 318 , 239 , 2 , Red
   Wait 3

   Lcd_clear Black
   Lcd_text "12:34" , 50 , 10 , 4 , Red , Black , 1
   Lcd_text "123456" , 50 , 50 , 4 , Yellow , Black , 1
   Lcd_text "12,89" , 50 , 100 , 4 , Green , Black , 1
   Lcd_text "6895.54" , 10 , 160 , 4 , White , Black , 1
   Wait 3
   Lcd_clear Black
   Lcd_text "12:34" , 50 , 10 , 1 , Red , Black , 1
   Lcd_text "123456" , 50 , 50 , 1 , Yellow , Black , 1
   Lcd_text "12,89" , 50 , 100 , 1 , Green , Black , 1
   Lcd_text "6895.54" , 10 , 160 , 1 , White , Black , 1
   Wait 3

    ' =========== Invert ============

   Lcd_invert 1
   Wait 3
   Lcd_invert 0
   Wait 3
   Lcd_clear Black
   Lcd_ellipse 50 , 50 , 100 , 120 , Yellow
   Wait 3
   #if Use_touch = 1
   Wait 3
      Touch_flag = 0
      Lcd_box 270 , 210 , 40 , 25 , 2 , Blue , Red
      Do

         If Touch_flag = 1 Then
            Lcd_read_touch
            Lcd_fill_circle Touchx , Touchy , 2 , Yellow
            Help_str = Str(touchx)
            Temp_str = "X "
            Temp_str = Temp_str + Format(help_str , "0000")
            Lcd_text Temp_str , 10 , 1 , 2 , Yellow , Black , 1
            Help_str = Str(touchy)
            Temp_str = "Y "
            Temp_str = Temp_str + Format(help_str , "0000")
            Lcd_text Temp_str , 110 , 1 , 2 , Yellow , Black , 1

          '  Touch_flag = 0

            Select Case Touchx
             Case 270 To 310 :
             If Touchy > 210 And Touchy < 235 Then
             Ende = 1
             End If
            End Select

         End If


          If Ende = 1 Then
            Ende = 0
            Exit Do
           End If

      Loop
    #endif
'*******************************************************************************
'-------------------------------------------------------------------------------
 #if Sd_card = 1
   Lcd_clear Black
   Lcd_pic_binsd "bild1.bin" , 0 , 0 , 320 , 240
   Wait 2
   Lcd_clear Black
   Lcd_draw_bmp "bild1.bmp" , 0 , 0
   Wait 1
 #endif

' Draw Box x start -- y start -- width -- height -- 1=fill 2=fill with Border 3=no fill -- color -- bordercolor
      Lcd_clear Black
      Lcd_box 10 , 10 , 300 , 220 , 2 , Red , Blue
      Lcd_box 30 , 30 , 260 , 180 , 2 , Blue , Yellow
      Lcd_box 50 , 50 , 220 , 140 , 2 , Green , White
      Lcd_box 70 , 70 , 180 , 100 , 2 , Red , Blue
      Lcd_box 90 , 90 , 140 , 60 , 2 , Yellow , Green
      Wait 1
      Lcd_clear Black
      Lcd_box 10 , 10 , 300 , 220 , 1 , Red , Blue
      Lcd_box 30 , 30 , 260 , 180 , 1 , Blue , Yellow
      Lcd_box 50 , 50 , 220 , 140 , 1 , Green , White
      Lcd_box 70 , 70 , 180 , 100 , 1 , Red , Blue
      Lcd_box 90 , 90 , 140 , 60 , 1 , Yellow , Green
      Wait 1
      Lcd_clear Black
      Lcd_box 10 , 10 , 300 , 220 , 3 , Red , Blue
      Lcd_box 30 , 30 , 260 , 180 , 3 , Blue , Yellow
      Lcd_box 50 , 50 , 220 , 140 , 3 , Green , White
      Lcd_box 70 , 70 , 180 , 100 , 3 , Red , Blue
      Lcd_box 90 , 90 , 140 , 60 , 3 , Yellow , Green
      Wait 1
      Lcd_clear Black
      Lcd_fill_triangle 70 , 120 , 130 , 150 , 130 , 90 , Green

      Lcd_fill_triangle 130 , 90 , 190 , 90 , 160 , 30 , Red

      Lcd_fill_triangle 190 , 150 , 250 , 120 , 190 , 90 , Yellow

      Lcd_fill_triangle 130 , 150 , 190 , 150 , 160 , 210 , Blue

      Wait 5

      Lcd_clear Black
      Lcd_triangle 70 , 120 , 130 , 150 , 130 , 90 , Green

      Lcd_triangle 130 , 90 , 190 , 90 , 160 , 30 , Red

      Lcd_triangle 190 , 150 , 250 , 120 , 190 , 90 , Yellow

      Lcd_triangle 130 , 150 , 190 , 150 , 160 , 210 , Blue

      Wait 5
      Lcd_clear Black

   Lcd_text "Font" , 100 , 10 , 2 , Yellow , Black , 2       'Font Bold x2
   Lcd_text "12x16" , 88 , 85 , 2 , Yellow , Black , 2
   Lcd_text "x2" , 124 , 140 , 2 , Yellow , Black , 2
   Wait 1
   Lcd_clear Black
   Lcd_text "Font" , 88 , 10 , 2 , Yellow , Black , 3       'Font Bold x3
   Lcd_text "12x16" , 64 , 85 , 2 , Yellow , Black , 3
   Lcd_text "x3" , 112 , 150 , 2 , Yellow , Black , 3
   Wait 1
   Lcd_clear Black
   Lcd_text "Font" , 64 , 10 , 2 , Yellow , Black , 4       'Font Bold x4
   Lcd_text "12x16" , 40 , 85 , 2 , Yellow , Black , 4
   Lcd_text "x4" , 100 , 160 , 2 , Yellow , Black , 4
   Wait 1
   Lcd_clear Black
'-------------------------------------------------------------------------------
   Lcd_text "Line" , 10 , 10 , 2 , Blue , Black , 1
   For Dumb = 50 To 190 Step 5
      Lcd_line 1 , 120 , 300 , Dumb , 1 , Yellow
   Next

   For Dumb = 50 To 190 Step 5
      Lcd_line 319 , 120 , 19 , Dumb , 1 , Green
   Next

   For Dumb = 50 To 280 Step 5
      Lcd_line 160 , 239 , Dumb , 30 , 1 , Red
   Next

   For Dumb = 50 To 280 Step 5
      Lcd_line 160 , 1 , Dumb , 200 , 1 , Blue
   Next

   Wait 2
   Lcd_clear White
   Lcd_text "Circle" , 10 , 10 , 2 , Blue , White , 1
    Lcd_circle 160 , 120 , 20 , Red
   For Zahler = 20 To 100 Step 5
    Lcd_circle 160 , 120 , Zahler , Red
   Next

   Wait 1
   Lcd_clear White
   Lcd_text "Circle" , 10 , 10 , 2 , Blue , White , 1
   Lcd_fill_circle 60 , 60 , 30 , Green
   Lcd_fill_circle 160 , 60 , 30 , Red
   Lcd_fill_circle 260 , 60 , 30 , Blue

   Lcd_fill_circle 60 , 140 , 20 , Red
   Lcd_fill_circle 160 , 140 , 20 , Blue
   Lcd_fill_circle 260 , 140 , 20 , Green

   Lcd_fill_circle 60 , 190 , 10 , Blue
   Lcd_fill_circle 160 , 190 , 10 , Green
   Lcd_fill_circle 260 , 190 , 10 , Red

   Wait 2
   Lcd_clear Black
   Lcd_text "BGC Files" , 10 , 10 , 2 , Yellow , Black , 2

   Restore Miky1
   Lcd_show_bgc 200 , 100
   Restore Miky1
   Lcd_show_bgc 20 , 100

   Wait 2
   Lcd_clear Red
   Wait 1
   Lcd_clear Green
   Wait 1
   Lcd_clear Black
  ' Restore Pic3
  ' Lcd_pic_sram 0 , 0 , 240 , 240
  ' Wait 10



#endif

Loop


End
'*******************************************************************************
#if Use_touch = 1
   Touch_int:
    '  Print "touch flag"                                    'Test Interrupt
      Touch_flag = 1
   Return
#endif

#if Sd_card = 1
   $include "Avr-Dos\SD_card_init.inc"
#endif
$include "TFTDriver\ILI9341_functions8.inc"

$include "Font\Droidsans16x24.font"       'Font 1
$include "Font\My12x16.font"       'Font 2
$include "Font\crn20x24.font"       'Font 3
$include "Font\Digital20x32.font"       'Font 4
$include "Font\My6x8.font"       'Font 5

'$inc Pic2 , Nosize , "Bilder\75x108.bin"       '75x108
'$inc Pic3 , Nosize , "Bilder\sunset.bin"       '75x108
Miky1:
'   $bgf "Bilder\miky1.bgc"
Post:
'   $bgf "Bilder\post.bgc"