'*******************************************************************************
'Display Driver IC ILI9341 320x240 Pixel
'
'Modus 16Bit
'
'Landscape and Portrait
'
'Bascom version 2.0.7.8
'Date 01.03.2015
'
'Autor: Hkipnik@aol.com
'
'Copyright by Hkipnik@aol.com
'
'
' der RD Pin vom Display an 3,3V legen
' Test whith Levelshift 5V --> 3,3V
'
' Hardware: Buy Display ER-TFTM024-3 2,4 inch TFT LCD Display Module
'           wiht adaptor board  240x320 Pixel
'
'*******************************************************************************

$nocompile

'*******************************************************************************
' Draw BMP Picture with 24Bit Color
'*******************************************************************************
#if Sd_card = 1
Sub Lcd_draw_bmp(byval Filename As String , Byval Xpos As Word , Byval Ypos As Word)

      Local X As Word
      Local Line_len As Word
      Local Y As Single , Z As Word , Line_count As Word
      Local Bmp_read_pos As Long
      Local Xad As Word
      Local Yad As Word


      Local Bfoffbits As Long

      Dim Biwidth As Word                                   'normaly long, but we can't handle bigger bmp's!
      Dim Biheight As Word                                  'normaly long, but we can't handle bigger bmp's!
      Local Bibitcount As Word


      Reset Mmc_cs
      Open Filename For Binary As #10


      Get #10 , Bfoffbits , &H0B                            '&H0A + 1
      Get #10 , Biwidth , &H013                             '&H12 + 1
      Get #10 , Biheight , &H017                            '&H16 + 1
      Get #10 , Bibitcount , &H1D                           '&H1C + 1



    Xad = Biwidth + Xpos
    Yad = Biheight + Ypos
    Decr Xad


      Call Lcd_set_window(xpos , Ypos , Xad , Yad)


      Config Single = Scientific , Digits = 1

     '  Incr Biheight
      Incr Biheight
      If Bibitcount = 24 Then
        ' position behind BMP Header Data
        Bmp_read_pos = Bfoffbits + 1
        ' we need line length divideable by 4!
        Line_byte = Biwidth * 3
        Line_len = Biwidth Mod 4
        Line_len = Line_byte + Line_len
      '  Print "MOD 4  Line-len : " ; Line_len
         Set Rs_disp
     '    Reset Cs_disp


         !LDS     R30,       {Biheight}                     'Anzahl lines in y-Register
         !LDS     R31,       {Biheight+1}
         !SBIW    R30, 1
         Loop_rows:
           !push    R30
           !push    R31
           Get #10 , Rgb_data(1) , Bmp_read_pos , Line_len

           'THX MWS!!!!
               !LDS     R30,       {Biwidth}                'Anzahl Pixel/line in Z-Register
               !LDS     R31,       {Biwidth+1}

               Loadadr Rgb_data(1) , X

           Loop_line:
               !LD      R16,        X+                      ' blau in R16
               !LD      R17,        X+                      ' gruen in R17
               !LD      R18,        X+                      ' rot in R18
               !ANDI    R18,        &b11111000              ' unnoetiges ausmaskieren

               'GRN
               !ROL     R17                                 ' 4 mal rotieren, da erstes Bit zuerst ins Carry geht
               !ROL     R17
               !ROL     R17
               !ROL     R17                                 ' Bits 7..5 von gruen sind nun an Bit 2..0 fuer Rgb_HB
               !MOV     R24,        R17                     ' nach R24 sichern
               !ROR     R17                                 ' 1 mal aus dem Carry zurck rotieren, um die Bits 4..2 auf 7..5 zu bekommen
               !ANDI    R17,        &b11100000              ' Bit 7..5 von gruen maskieren, fuer Rgb_LB
               !ANDI    R24,        &b00000111              ' Bit 2..0 maskieren fuer Rgb_HB

               'BLAU
               !LSR     R16                                 ' R16, blau 3mal rechts schieben
               !LSR     R16
               !LSR     R16
               !OR      R24,        R18
               !OUT    Data_disp, R24
               !OR     R17,        R16
               !OUT    Data_disp_low, R17
               !cBI Port_wr, Wrpin                          'WR Pin
               !SBI Port_wr, Wrpin
               !SBIW  R30, 1                                'decr Z-Register
               !BRNE Loop_line

           Bmp_read_pos = Bmp_read_pos + Line_len

          !pop    R31
          !pop    R30
          !SBIW   R30, 1                                    'decr Z-Register
          !BREq   End_rows
          !Rjmp   Loop_rows
          End_rows:

     '   Set Cs_disp
      End If

      Close #10
      Set Mmc_cs
   Config Single = Scientific , Digits = 7

End Sub

'*******************************************************************************
' Draw pic from SD Card with Bin File
' Bin File created with IMG2LCD Program
'*******************************************************************************
Sub Lcd_pic_binsd(byval Filename As String , Byval Xpos As Word , Byval Ypos As Word , Byval Width As Word , Byval Height As Word)
   Local Xend As Word , Yend As Word , Linelen As Word
 '  Local Read_pos As Dword

   Linelen = 2 * Width
   Xend = Xpos + Width
   Yend = Ypos + Height
   Breit = Width
   Hoehe = Height
   Decr Xend

   Call Lcd_set_window(xpos , Ypos , Xend , Yend)           'Mode1

   Cs_disp = 0
   Rs_disp = 1
  ' Read_pos = 1
   Reset Mmc_cs
   Open Filename For Binary As #10

      !LDS     R30,       {Hoehe}                           'Anzahl lines
      !LDS     R31,       {Hoehe+1}
    Loop_2:
      !push    R30
      !push    R31

     Get #10 , Rgb_data(1) , , Linelen                      'Read_pos

     !LDS     R30,       {breit}                            'Anzahl breite
     !LDS     R31,       {breit+1}

     Loadadr Rgb_data(1) , X
   Loop_1:
      !LD R16, X+
      !LD R17, X+
      !OUT    Data_disp, R16
      !OUT    Data_disp_low, R17
      !cBI Port_wr, Wrpin                                   'WR Pin
      !SBI Port_wr, Wrpin
      !SBIW  R30, 1                                         'decr breit   30
      !BRNE Loop_1
   '  Read_pos = Read_pos + Linelen
      !pop    R31
      !pop    R30
      !SBIW   R30, 1                                        'decr lines
      !BREq   End_1
      !Rjmp   Loop_2
   End_1:

   Close #10
   Set Mmc_cs
   End Sub

#endif
'*******************************************************************************
' Draw Pic x start -- y start -- Breite -- Hhe from SRAM  Bin file
' before Call Sub you must Restore the Label
'*******************************************************************************
Sub Lcd_pic_sram(byval Xs As Word , Byval Ys As Word , Byval Breite As Word , Byval Height As Word )
  Local Zal As Word , Xe As Word , Yss As Word
  Local R1 As Byte , R2 As Byte
  Local Lang As Word
  Lang = Breite * Height
  Xe = Xs + Breite
  Yss = Ys + Height
  Decr Xe
  Call Lcd_set_window(xs , Ys , Xe , Yss)
' Cs_disp = 0
 Rs_disp = 1
  For Zal = 1 To Lang
    Read R1
    Read R2
     Data_disp = R1
     Data_disp_low = R2
     Wr_disp = 0
     Wr_disp = 1
  Next
'   Cs_disp = 1
End Sub
'*******************************************************************************
' Set Window Area to write Data
'*******************************************************************************
Sub Lcd_set_window(byval Xpos As Word , Byval Ypos As Word , Byval Xsize As Word , Byval Ysize As Word)

   Rs_disp = 0                                              'command
   !ldi R16,$2a
   !Out Data_disp_low , r16
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin


   !ldd R26, Y+6                                            ' xpos
   !Ldd R27, Y+7
   !LD R18, X+
   !LD R17, X

   Rs_disp = 1
   !Out Data_disp_low , R17
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin
   !Out Data_disp_low , R18
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin


   !ldd R26, Y+2                                            ' xsize
   !Ldd R27, Y+3
   !LD R18, X+
   !LD R17, X
   !Out Data_disp_low , R17
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin
   !Out Data_disp_low , R18
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin

   Rs_disp = 0                                              'command
   !ldi R16,$2b
   !Out Data_disp_low , r16
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin

   !ldd R26, Y+4                                            ' ypos
   !Ldd R27, Y+5
   !LD R18, X+
   !LD R17, X
   Rs_disp = 1
   !Out Data_disp_low , R17
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin
   !Out Data_disp_low , R18
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin


   !ldd R26, Y+0                                            ' ysize
   !Ldd R27, Y+1
   !LD R18, X+
   !LD R17, X
   !Out Data_disp_low , R17
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin
   !Out Data_disp_low , R18
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin

   Rs_disp = 0                                              'command
   !ldi R16,$2c
   !Out Data_disp_low , r16
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin

End Sub
'*******************************************************************************
' Set_pixel  Set one Pixel in given color
'*******************************************************************************
Sub Lcd_set_pixel(byval X1 As Word , Y1 As Word , Color As Word)

   Rs_disp = 0                                              'command
   !ldi R16,$2a
   !Out Data_disp_low , r16
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin

   !ldd R26, Y+4
   !Ldd R27, Y+5
   !LD R10, X+
   !LD R11, X
   Rs_disp = 1
   !Out Data_disp_low , R11
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin
   !Out Data_disp_low , R10
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin

   !Out Data_disp_low , R11
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin
   !Out Data_disp_low , R10
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin

   Rs_disp = 0
   !ldi R16,$2b
   !Out Data_disp_low , r16
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin


   !ldd R26, Y+2
   !Ldd R27, Y+3
   !LD R10, X+
   !LD R11, X
   Rs_disp = 1
   !Out Data_disp_low , R11
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin
   !Out Data_disp_low , R10
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin

   !Out Data_disp_low , R11
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin
   !Out Data_disp_low , R10
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin


   Rs_disp = 0
   !ldi R16,$2c
   !Out Data_disp_low , r16
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin


   !ldd R26, Y+0
   !Ldd R27, Y+1
   !LD R10, X+
   !LD R11, X
   Rs_disp = 1
   !Out Data_disp , R11
   !Out Data_disp_low , R10
   !cBI Port_wr, Wrpin
   !SBI Port_wr, Wrpin


End Sub
'*******************************************************************************
' Draw Text String  x y Start - Font Nr - Forecolor - Backcolor - Bold Nr 1 - 2 - 3 -4  1 is normal
'*******************************************************************************
Sub Lcd_text(byval Lcd_text As String , Byval Lcd_posx As Word , Byval Lcd_posy As Word , Byval Fontset As Byte , Byval Forecolor As Word , Byval Backcolor As Word , Byval Bold As Byte)

   Local Pzeichen As String * 1
   Local Zeichen_row As Word
   Local Ptemp As Word
   Local Ptemp2 As Word
   Local Px As Word
   Local Py As Word
   Local Char_rows As Byte
   Local Char_row_len As Byte
   Local Char_bytes As Byte
   Local Dummy As Byte
   Local String_pos As Byte
   Local Zeichen_code As Word
   Local Fcolh As Byte , Fcoll As Byte , Bacolh As Byte , Bacoll As Byte
   Local Doph As Word , Zbv As Byte
   Fcolh = High(forecolor)
   Fcoll = Low(forecolor)
   Bacolh = High(backcolor)
   Bacoll = Low(backcolor)
    Cs_disp = 0
      Select Case Fontset
         Case 2:
            Char_rows = Lookup(0 , Font12x16)
            Char_row_len = Lookup(1 , Font12x16)
            Char_bytes = Lookup(2 , Font12x16)
            Dummy = Lookup(3 , Font12x16)
         Case 1:
            Char_rows = Lookup(0 , Font25x32)
            Char_row_len = Lookup(1 , Font25x32)
            Char_bytes = Lookup(2 , Font25x32)
            Dummy = Lookup(3 , Font25x32)
         Case 3:
            Char_rows = Lookup(0 , Crn20x24)
            Char_row_len = Lookup(1 , Crn20x24)
            Char_bytes = Lookup(2 , Crn20x24)
            Dummy = Lookup(3 , Crn20x24)
         Case 4:
            Char_rows = Lookup(0 , Digital20x32)
            Char_row_len = Lookup(1 , Digital20x32)
            Char_bytes = Lookup(2 , Digital20x32)
            Dummy = Lookup(3 , Digital20x32)
      End Select

   For String_pos = 1 To Len(lcd_text)                      'Fr jedes Zeichen im String
      Pzeichen = Mid(lcd_text , String_pos , 1)             'Ein Zeichen aus String holen
      Zeichen_code = Asc(pzeichen) - 32                     'Font files start with caracter 32
      Zeichen_code = Zeichen_code * Char_bytes

      Doph = Zeichen_code
      Doph = Doph + 4
      For Px = 1 To Char_bytes

         Select Case Fontset
            Case 1 : Zeichenarray(px) = Lookup(doph , Font25x32)
            Case 2 : Zeichenarray(px) = Lookup(doph , Font12x16)
            Case 3 : Zeichenarray(px) = Lookup(doph , Crn20x24)
            Case 4 : Zeichenarray(px) = Lookup(doph , Digital20x32)
         End Select
         Incr Doph

      Next Px

      Py = Char_rows * 8
      Py = Py * Bold
      Py = Py + Lcd_posy

      Px = String_pos - 1
      Px = Px * Char_row_len
      Px = Px + Lcd_posx

         Select Case Bold
            Case 1:
               Ptemp = Px + Char_row_len
            Case 2:
               Px = Px * Bold                               '* 2
               Px = Px - Lcd_posx
               Ptemp = Px + Char_row_len
               Ptemp = Ptemp + Char_row_len
            Case 3:
               Px = Px * Bold                               '* 3
               Px = Px - Lcd_posx
               Px = Px - Lcd_posx
               Ptemp = Px + Char_row_len
               Ptemp = Ptemp + Char_row_len
               Ptemp = Ptemp + Char_row_len
            Case 4:
               Px = Px * Bold                               '* 4
               Px = Px - Lcd_posx
               Px = Px - Lcd_posx
               Px = Px - Lcd_posx
               Ptemp = Px + Char_row_len
               Ptemp = Ptemp + Char_row_len
               Ptemp = Ptemp + Char_row_len
               Ptemp = Ptemp + Char_row_len
         End Select

      Decr Ptemp

      Call Lcd_set_window(px , Lcd_posy , Ptemp , Py)
  '    Cs_disp = 0
      Set Rs_disp

      For Py = 1 To Char_rows
         Ptemp = Py - 1
         Ptemp = Ptemp * Char_row_len

         For Zeichen_row = 0 To 7
            For Doph = 1 To Bold
               For Px = 1 To Char_row_len
                  Ptemp2 = Ptemp + Px
                  If Zeichenarray(ptemp2).zeichen_row = 1 Then

                        For Zbv = 1 To Bold
                            Data_disp = Fcolh               'Rgb16_high
                            Data_disp_low = Fcoll
                           !cBI Port_wr, Wrpin              'WR Pin
                           !SBI Port_wr, Wrpin
                        Next Zbv

                  Else

                        For Zbv = 1 To Bold
                           Data_disp = Bacolh               'Rgb16_high
                           Data_disp_low = Bacoll
                           !cBI Port_wr, Wrpin              'WR Pin
                           !SBI Port_wr, Wrpin
                        Next Zbv

                  End If
               Next Px
            Next Doph
         Next Zeichen_row
      Next Py


   Next String_pos

End Sub
'*******************************************************************************
' Draw line X - Y Start to X - Y End - Pen Width - Color
'*******************************************************************************
Sub Lcd_line(byval X1 As Word , Byval Y1 As Word , Byval X2 As Word , Byval Y2 As Word , Byval Pen_width As Byte , Byval Color As Word)
   Local Y As Word , X As Word , X_diff As Single , Y_diff As Single , Pos As Word
   Local X_factor As Single , X_pos As Word , Y_pos As Word , Base As Word , Pen_count As Byte


   Y_diff = Y2 - Y1
   X_diff = X2 - X1
   Pos = 0

   X_factor = Abs(y_diff)
   Y = X_factor
   X_factor = Abs(x_diff)
   X = X_factor

   If Y > X Then
      X_factor = X_diff / Y_diff
      If Y1 > Y2 Then
         Swap Y1 , Y2
         Base = X2
      Else
         Base = X1
      End If
      For Y = Y1 To Y2
         X_diff = Pos * X_factor
         X_pos = X_diff
         X_pos = X_pos + Base
         For Pen_count = 1 To Pen_width
             Call Lcd_set_pixel(x_pos , Y , Color)
             Incr X_pos
         Next Pen_count
         Incr Pos
      Next Y
   Else
      X_factor = Y_diff / X_diff
      If X1 > X2 Then
          Swap X1 , X2
         Base = Y2
      Else
         Base = Y1
      End If
      For X = X1 To X2
         Y_diff = Pos * X_factor
         Y_pos = Y_diff
         Y_pos = Y_pos + Base
         For Pen_count = 1 To Pen_width
            Call Lcd_set_pixel(x , Y_pos , Color)
            Incr Y_pos
         Next Pen_count
         Incr Pos
      Next X
   End If
End Sub
'*******************************************************************************
' Draw Box x start -- y start -- width -- height -- 1=fill 2=fill with Border 3=no fill -- color -- bordercolor
'*******************************************************************************
Sub Lcd_box(byval Xstart As Word , Byval Ystart As Word , Byval X_length As Word , Byval Y_height As Word , Byval Fill As Byte , Byval Color As Word , Byval Bordercolor As Word)
    Local Xend As Word , Yend As Word
   Xend = Xstart + X_length
   Yend = Ystart + Y_height
   Hoehe = X_length
   Breit = Y_height + Ystart
   If Fill = 1 Then
      Call Lcd_set_window(xstart , Ystart , Xend , Yend )

      Rgb16 = Color
   '   Cs_disp = 0
      Rs_disp = 1


      !LDS     R30,       {Hoehe}                           'Anzahl lines
      !LDS     R31,       {Hoehe+1}
      Lo_rows:
         !push    R30
         !push    R31

         !LDS     R30,       {Breit}                        'Anzahl Pixel pro line
         !LDS     R31,       {Breit+1}

      Lo_line:
         Data_disp = Rgb16_high
         Data_disp_low = Rgb16_low
         !cBI Port_wr, Wrpin                                'Port_wr, Wrpin                                'WR Pin
         !SBI Port_wr, Wrpin                                'Port_wr, Wrpin

         !SBIW  R30, 1                                      'decr Pixel
         !BRNE Lo_line

         !pop    R31
         !pop    R30
         !SBIW   R30, 1                                     'decr hhe
         !BREq   End_ro
         !Rjmp   Lo_rows
      End_ro:

   Elseif Fill = 2 Then
      Call Lcd_set_window(xstart , Ystart , Xend , Yend )

      Rgb16 = Color
      Cs_disp = 0
      Rs_disp = 1

      !LDS     R30,       {Hoehe}                           'Anzahl lines
      !LDS     R31,       {Hoehe+1}
      Lo_rows1:
         !push    R30
         !push    R31

         !LDS     R30,       {Breit}                        'Anzahl Pixel pro line
         !LDS     R31,       {Breit+1}

      Lo_line1:
         Data_disp = Rgb16_high
         Data_disp_low = Rgb16_low
         !cBI Port_wr, Wrpin                                ' Port_wr, Wrpin                                'WR Pin
         !SBI Port_wr, Wrpin                                'Port_wr, Wrpin

         !SBIW  R30, 1                                      'decr Breite
         !BRNE Lo_line1


         !pop    R31
         !pop    R30
         !SBIW   R30, 1                                     'decr Hoehe
         !BREq   End_ro1                                    'fertig und raus
         !Rjmp   Lo_rows1
      End_ro1:

   Call Lcd_line(xstart , Ystart , Xend , Ystart , 2 , Bordercolor)
   Call Lcd_line(xstart , Yend , Xend , Yend , 2 , Bordercolor)
   Call Lcd_line(xstart , Ystart , Xstart , Yend , 2 , Bordercolor)
   Call Lcd_line(xend , Ystart , Xend , Yend , 2 , Bordercolor)
 Elseif Fill = 3 Then
   Call Lcd_line(xstart , Ystart , Xend , Ystart , 2 , Bordercolor)
   Call Lcd_line(xstart , Yend , Xend , Yend , 2 , Bordercolor)
   Call Lcd_line(xstart , Ystart , Xstart , Yend , 2 , Bordercolor)
   Call Lcd_line(xend , Ystart , Xend , Yend , 2 , Bordercolor)
 End If

End Sub

'*******************************************************************************
' Lcd show BGC File  X Start  Y Start
' Important that you first RESTORE the image before calling this sub
'*******************************************************************************
Sub Lcd_show_bgc(byval Xoffset As Word , Byval Yoffset As Word)

Local Ysize2 As Byte , Xsize2 As Byte
Local Imagesize As Word
Local L As Word , Pixel As Byte ,
Local Pixelword As Word , Prevpixel As Word , Repeat As Byte
Local X1size As Word , Y1size As Word 


Read Ysize2                                                 'Read the first 4 bytes from the BGC, this contains info about the image
Read Xsize2
Read Imagesize                                              'Byte 3&4 contains the image size

X1size = Xsize2 + Xoffset
Y1size = Ysize2 + Yoffset
Decr X1size


  Call Lcd_set_window(xoffset , Yoffset , X1size , Y1size)
  Rs_disp = 1
  Do
      Read Pixel                                            'Read the value for the pixel
      If Pixel = &HAA Then                                  'BGC file is rle coded &HAA represents this, the byte after &HAA is the number of times that the byte before &HAA wil be repeated
         Read Repeat                                        'Byte after &HAA contains the number of times to repeat
         Repeat = Repeat - 1
         For L = 1 To Repeat                                'Loop the repeat
            Data_disp = Rgb16_high                          ' High(daten)
            Data_disp_low = Rgb16_low                       ' High(daten)
            Wr_disp = 0
            Wr_disp = 1
            Decr Imagesize                                  'Decrease the bytes still to be processed
         Next L                                             'Next repeat loop
      Else
         Rgb16 = Rgb8to16(pixel)
         Data_disp = Rgb16_high                             ' High(daten)
         Data_disp_low = Rgb16_low                          ' High(daten)
         Wr_disp = 0
         Wr_disp = 1
         Decr Imagesize
      End If
   Loop Until Imagesize = 0                                 'Do until all bytes are processed

End Sub

'*******************************************************************************
' Clear LCD with color
'*******************************************************************************
Sub Lcd_clear(byval Color As Word)

   Call Lcd_set_window(0 , 0 , X_size , Y_size)

 '  Cs_disp = 0
   Rs_disp = 1
      !ldd R26, Y+0                                         ' color
      !LDD R27, Y+1
      !ld R20, X+
      !LD R21, X
      !Out Data_disp , R21
      !Out Data_disp_low , R20

      !ldi  R16, $F0                                        '76800   240
   Wgloop0:
      !ldi  R24, $40                                        '320
      !ldi  R25, $01
   Wloop1:
      !cBI Port_wr, Wrpin
      !SBI Port_wr, Wrpin

      !sbiw R24, 1
      !brne wloop1


      !subi R16, 1
      !brne wgloop0

  ' Cs_disp = 1

End Sub
'*******************************************************************************
' draw Circle  X - Y Center - Radius - Color
'*******************************************************************************
Sub Lcd_circle(byval X As Word , Byval Y As Word , Byval Radius As Word , Byval Color As Word)
   Local X0 As Word , Y0 As Word , Error As Integer
   Local Xp As Word , Yp As Word , Xe As Word , Ye As Word
   Error = -radius
   Xp = Radius
   Yp = 0

   While Xp >= Yp
      X0 = X + Xp : Y0 = Y + Yp
      Call Lcd_set_pixel(x0 , Y0 , Color)
      X0 = X - Xp : Y0 = Y + Yp
      Call Lcd_set_pixel(x0 , Y0 , Color)
      X0 = X + Xp : Y0 = Y - Yp
      Call Lcd_set_pixel(x0 , Y0 , Color)
      X0 = X - Xp : Y0 = Y - Yp
      Call Lcd_set_pixel(x0 , Y0 , Color)

      X0 = X + Yp : Y0 = Y + Xp
      Call Lcd_set_pixel(x0 , Y0 , Color)
      X0 = X - Yp : Y0 = Y + Xp
      Call Lcd_set_pixel(x0 , Y0 , Color)
      X0 = X + Yp : Y0 = Y - Xp
      Call Lcd_set_pixel(x0 , Y0 , Color)
      X0 = X - Yp : Y0 = Y - Xp
      Call Lcd_set_pixel(x0 , Y0 , Color)
      Error = Error + Yp
      Incr Yp
      Error = Error + Yp

      If Error >= 0 Then
         Decr Xp
         Error = Error - Xp
         Error = Error - Xp
      End If
   Wend
End Sub
'*******************************************************************************
'LCD Fill Circle X Y center -- Radius -- Color
'*******************************************************************************
Sub Fill_circle(byval X As Word , Byval Y As Word , Byval Radius As Word , Byval Color1 As Word)
Local Count_y As Integer , Count_x As Integer
Local Y1 As Integer , X1 As Integer , Xy_radius As Integer
Local Y11 As Integer , X11 As Integer , Xy As Integer , Tempxy As Word , Tempx As Word

 Rgb16 = Color1
 Xy_radius = Radius * Radius
 Y1 = -radius
 X1 = -radius
For Count_y = Y1 To Radius
   Y11 = Count_y * Count_y
   Tempxy = Y + Count_y

   For Count_x = X1 To Radius
      X11 = Count_x * Count_x
      Xy = X11 + Y11
      If Xy <= Xy_radius Then
         Tempx = X + Count_x
      Rgb16 = Tempx

      Rs_disp = 0                                           'command
      Data_disp = 0
      Data_disp_low = &H2A
      Wr_disp = 0
      Wr_disp = 1

      Rs_disp = 1                                           'data
      Data_disp_low = Rgb16_high
      Wr_disp = 0
      Wr_disp = 1
      Data_disp_low = Rgb16_low
      Wr_disp = 0
      Wr_disp = 1
      Data_disp_low = Rgb16_high
      Wr_disp = 0
      Wr_disp = 1
      Data_disp_low = Rgb16_low
      Wr_disp = 0
      Wr_disp = 1

      Rgb16 = Tempxy
      Rs_disp = 0
      Data_disp_low = &H2B
      Wr_disp = 0
      Wr_disp = 1

      Rs_disp = 1                                           'command
      Data_disp_low = Rgb16_high
      Wr_disp = 0
      Wr_disp = 1
      Data_disp_low = Rgb16_low
      Wr_disp = 0
      Wr_disp = 1
      Data_disp_low = Rgb16_high
      Wr_disp = 0
      Wr_disp = 1
      Data_disp_low = Rgb16_low
      Wr_disp = 0
      Wr_disp = 1

      Rs_disp = 0
      Data_disp_low = &H2C
      Wr_disp = 0
      Wr_disp = 1

     Rgb16 = Color1
   '
     Rs_disp = 1
     Data_disp = Rgb16_high                                 'High(daten)
     Data_disp_low = Rgb16_low                              'Low(daten
     Wr_disp = 0
     Wr_disp = 1
      End If
   Next Count_x
Next Count_y
End Sub
'*******************************************************************************
'Draw Triangle
'*******************************************************************************
'
'   Xa-Ya    Xb-Yb
'     ________            Xc-Yc
'     \      /             /\
'      \    /             /  \
'       \ /              /    \
'      Xc-Yc             ------
'                     Xa-Ya   Xb-Yb
'*******************************************************************************
Sub Lcd_triangle(byval X_a As Word , Byval Y_a As Word , Byval X_b As Word , Byval Y_b As Word , Byval X_c As Word , Byval Y_c As Word , Byval Color As Word)

   Lcd_line X_a , Y_a , X_b , Y_b , 1 , Color
   Lcd_line X_b , Y_b , X_c , Y_c , 1 , Color
   Lcd_line X_c , Y_c , X_a , Y_a , 1 , Color

End Sub
'*******************************************************************************
'Draw Fill Triangle
'*******************************************************************************
'
'   Xa-Ya    Xb-Yb
'     ________            Xc-Yc
'     \      /             /\
'      \    /             /  \
'       \ /              /    \
'      Xc-Yc             ------
'                     Xa-Ya   Xb-Yb
'*******************************************************************************
Sub Lcd_fill_triangle(byval X_a As Word , Byval Y_a As Word , Byval X_b As Word , Byval Y_b As Word , Byval X_c As Word , Byval Y_c As Word , Byval Color As Word )
   Local X As Word , X_diff As Single , Y_diff As Single , Pos As Word
   Local X_factor As Single , Y_pos As Word , Pen_count As Word
   Local Zx_diff As Single , Zx_factor As Single
   Local Zy_diff As Single , Zy_factor As Single , Zy As Word , Xyz As Word
   Local Zy1_diff As Single , Zy1_factor As Single , Zy1 As Word , Xyz1 As Word

   Pen_count = 0
   Pos = 0
   Y_diff = Y_b - Y_a
   X_diff = X_b - X_a


   If Y_a < Y_c Then                                        'Yc greater Ya   YC down
      Zx_diff = X_c - X_a                                   'Xdiff left side
      Xyz = Abs(zx_diff)
      Zy_diff = Y_a - Y_c                                   'Ydiff Ya Yc
      Zy_factor = Zy_diff / Zx_diff
      Zy_factor = Abs(zy_factor)

      Zx_diff = X_b - X_c
      Zy1_diff = Y_b - Y_c
      Zy1 = Abs(zy1_diff)
      Zy1_factor = Zy1_diff / Zx_diff
      Zy1_factor = Abs(zy1_factor)
      Xyz1 = 1
      X_factor = Y_diff / X_diff                            'Xfactor Base line

      For X = X_a To X_b
         Y_diff = Pos * X_factor                            'find Y Start Pos
         Y_pos = Y_diff
         Y_pos = Y_pos + Y_a                                ' + Y Base

         If Pen_count <= Xyz Then                           'Left side
            Zy_diff = Pos * Zy_factor
            Zy = Y_pos + Zy_diff
            Zy1_diff = Y_a - Y_pos
            Zy = Zy + Zy1_diff

            Lcd_line X , Y_pos , X , Zy , 1 , Color

            Incr Pen_count
         Else                                               'Right side
            Zy_diff = Xyz1 * Zy1_factor
            Zy = Zy1 - Zy_diff
            Zy = Y_pos + Zy
            Zy1_diff = Y_b - Y_pos
            Zy = Zy + Zy1_diff

            Lcd_line X , Y_pos , X , Zy , 1 , Color

            Incr Xyz1
         End If
         Incr Pos
      Next X
   Else                                                     'Yc smaller Ya  YC up

      Zx_diff = X_c - X_a
      Xyz = Abs(zx_diff)
      Zy_diff = Y_c - Y_a
      Zy_factor = Zy_diff / Zx_diff
      Zy_factor = Abs(zy_factor)
      Zx_diff = X_b - X_c

      Zy1_diff = Y_b - Y_c
      Zy1 = Abs(zy1_diff)

      Zy1_factor = Zy1_diff / Zx_diff
      Zy1_factor = Abs(zy1_factor)
      Xyz1 = 1
      X_factor = Y_diff / X_diff

      For X = X_a To X_b
         Y_diff = Pos * X_factor                            'find Y Start Pos
         Y_pos = Y_diff
         Y_pos = Y_pos + Y_a                                'Base

         If Pen_count <= Xyz Then                           'Left side
            Zy_diff = Pos * Zy_factor
            Zy = Y_pos - Zy_diff
            Zy1_diff = Y_a - Y_pos
            Zy = Zy + Zy1_diff

            Lcd_line X , Y_pos , X , Zy , 1 , Color

            Incr Pen_count
         Else                                               'Right side
            Zy_diff = Xyz1 * Zy1_factor
            Zy = Zy1 - Zy_diff
            Zy = Y_pos - Zy
            Zy1_diff = Y_b - Y_pos
            Zy = Zy + Zy1_diff

            Lcd_line X , Y_pos , X , Zy , 1 , Color

            Incr Xyz1
         End If
         Incr Pos
      Next X
   End If
End Sub

'*******************************************************************************
' Read Touch  X  Y
'*******************************************************************************
#if Use_touch = 1
  Sub Lcd_read_touch()
      Local Res As Single
      Config Single = Scientific , Digits = 2
      Read_touch_raw

      Tx = Tx - X_offset
      Res = Tx / X_fact
      Touchx = Int(res)

      Ty = Ty - Y_offset
      Res = Ty / Y_fact
      Touchy = Int(res)

      If Touchx > 240 Then Touchx = 0
      If Touchy > 320 Then Touchy = 0

      #if Lcd_mode = 1
        If Xrotate = 1 Then
         Touchx = 240 - Touchx
        End If
        If Yrotate = 1 Then
         Touchy = 320 - Touchy
        End If
      #elseif Lcd_mode = 2
        If Xrotate = 0 Then
         Touchx = 240 - Touchx
        End If
        If Yrotate = 0 Then
         Touchy = 320 - Touchy
        End If
      #elseif Lcd_mode = 3
         Swap Touchx , Touchy                               'Wenn vertauscht bitte ndern
        If Yrotate = 0 Then                                 '1
         Touchx = 320 - Touchx
        End If
        If Xrotate = 1 Then                                 '0
         Touchy = 240 - Touchy
        End If
      #elseif Lcd_mode = 4
         Swap Touchx , Touchy
         If Yrotate = 1 Then                                '0
         Touchx = 320 - Touchx
         End If
         If Xrotate = 0 Then                                '1
         Touchy = 240 - Touchy
        End If
      #endif

      Config Single = Scientific , Digits = 7
   End Sub

'*******************************************************************************
' Read Data from Touchcontroller
'*******************************************************************************
   Sub Read_touch_raw()

   ' Disable Interrupts
   Clock = 0
   Cst = 0
   Waitms 10
   Shiftout Dout , Clock , X_dout , 1 , 8 , 40
   Waitms 5
   Shiftin Din , Clock , Touchx , 1 , 16 , 40
   Shiftout Dout , Clock , Y_dout , 1 , 8 , 40
   Waitms 5
   Shiftin Din , Clock , Touchy , 1 , 16 , 40
   Cst = 1

   Tx = Touchx And &B0111_1111_1111_1000
   Shift Tx , Right , 3
   'Print "xRaw= " ; Tx


   Ty = Touchy And &B0111_1111_1111_1000
   Shift Ty , Right , 3
   ' Print "yRaw= " ; Ty
   Waitms 300
   Touch_flag = 0
   ' Enable Interrupts
   End Sub
'(
Sub Read_touch_raw()
   Local Dum As Byte
   Disable Interrupts
  #if Sd_card = 1                                           'Config Spi for Touch Controler
   Spcr = &H53                                              'Config Spi Polarity = Low , Phase = 0 , Clockrate = 128
   Spsr = 0                                                 'no Double speed
  #endif
   Cst = 0
   Rawin(1) = Spimove(x_dout , 2)
   Cst = 1

   Waitms 3

   Cst = 0
   Rawin(3) = Spimove(y_dout , 2)
   Cst = 1

   Waitms 10
   Cst = 0
   Spiout X_dout , 1                                        'if Error then new Config Controler
   Cst = 1

  ' Touchx = Makeint(rawin(1) , Rawin(2))
  ' Touchy = Makeint(rawin(3) , Rawin(4))

 '  Print "Rawx= " ; Touchx
 '  Print "Rawy= " ; Touchy

   Tx = Touchx And &B0111_1111_1111_1000
   Shift Tx , Right , 3
 '  Print "xRaw= " ; Tx


   Ty = Touchy And &B0111_1111_1111_1000
   Shift Ty , Right , 3
  '  Print "yRaw= " ; Ty
   Waitms 300
   Touch_flag = 0
   Eifr.4 = 1                                               'Interrupt INT4 lschen
   Enable Interrupts

  #if Sd_card = 1                                           'Config SPI for SD Card
   Spcr = &H5C                                              'Config Spi Polarity = High , Phase = 1 , Clockrate = 4
   Spsr = 1                                                 'Double speed
  #endif
End Sub
')
'*******************************************************************************
'
'*******************************************************************************
   Sub Touch_calibrat()
      Local Xs As Word , Xe As Word , Ys As Word , Ye As Word
      Local Ydiff As Word , Yoff As Single
      Local Xdiff As Word , Xoff As Single
      Config Single = Scientific , Digits = 2

      Lcd_line 30 , 50 , 70 , 50 , 2 , Yellow               '1   x=50 y=50
      Lcd_line 50 , 30 , 50 , 70 , 2 , Yellow
      Lcd_text "1" , 45 , 80 , 2 , Red , Black , 1
      Lcd_line 170 , 50 , 210 , 50 , 2 , Yellow             '2   x=190 y=50
      Lcd_line 190 , 30 , 190 , 70 , 2 , Yellow
      Lcd_text "2" , 185 , 80 , 2 , Red , Black , 1
      Lcd_line 100 , 270 , 140 , 270 , 2 , Yellow           '3  x=120 y=270
      Lcd_line 120 , 250 , 120 , 290 , 2 , Yellow
      Lcd_text "3" , 115 , 290 , 2 , Red , Black , 1

      Wait 1
      Touch_flag = 0
      Lcd_text "Press 1" , 90 , 110 , 2 , Yellow , Black , 1
      Do
         If Touch_flag = 1 Then
            Read_touch_raw
            Xs = Tx
            Waitms 500
            Touch_flag = 0
            Exit Do
         End If
      Loop

      Lcd_text "Press 2" , 90 , 110 , 2 , Yellow , Black , 1
      Do
         If Touch_flag = 1 Then
            Read_touch_raw
            Xe = Tx
            Ys = Ty
            Waitms 500
            Touch_flag = 0
            Exit Do
         End If
      Loop


      Lcd_text "Press 3" , 90 , 110 , 2 , Yellow , Black , 1
      Do
         If Touch_flag = 1 Then
            Read_touch_raw
            Ye = Ty
            Waitms 500
            Touch_flag = 0
            Exit Do
         End If
      Loop

       If Xs > Xe Then
         Swap Xs , Xe
         Xrotate = 1
         Else
         Xrotate = 0
      End If

      If Ys > Ye Then
         Swap Ys , Ye
         Yrotate = 1
         Else
         Yrotate = 0
      End If


      Xdiff = Xe - Xs
      X_fact = Xdiff / 140
      Xoff = 50 * X_fact
      X_offset = Xs - Xoff

      Ydiff = Ye - Ys
      Y_fact = Ydiff / 220
      Yoff = 50 * Y_fact
      Y_offset = Ys - Yoff

      Xo = X_offset                                         'Daten in das Eeprom schreiben
      Yo = Y_offset
      Xf = X_fact
      Yf = Y_fact
      Xrotatee = Xrotate
      Yrotatee = Yrotate

      Config Single = Scientific , Digits = 7
   End Sub

#endif

'*******************************************************************************
' INIT ILI9341
'*******************************************************************************
Sub Lcd_init()
'reset
Res_disp = 1
Waitms 5
Res_disp = 0
Waitms 150
Res_disp = 1
Waitms 150
Cs_disp = 0

  'ER-TFTM024-3  2.4inch
   Call Lcd_select_reg(&Hcb)                                'Power control A    ILI9341
   Call Lcd_write_byte(&H39)
   Call Lcd_write_byte(&H2c)
   Call Lcd_write_byte(&H00)
   Call Lcd_write_byte(&H34)
   Call Lcd_write_byte(&H02)

   Call Lcd_select_reg(&Hcf)                                'Power control B
   Call Lcd_write_byte(&H00)
   Call Lcd_write_byte(&Hc1)                                '8b
   Call Lcd_write_byte(&H30)

   Call Lcd_select_reg(&He8)                                'Driver timing control A (
   Call Lcd_write_byte(&H85)
   Call Lcd_write_byte(&H00)
   Call Lcd_write_byte(&H78)


   Call Lcd_select_reg(&Hea)                                'Driver timing control B
   Call Lcd_write_byte(&H00)
   Call Lcd_write_byte(&H00)


   Call Lcd_select_reg(&Hed)                                'Power on sequence control
   Call Lcd_write_byte(&H64)
   Call Lcd_write_byte(&H03)
   Call Lcd_write_byte(&H12)
   Call Lcd_write_byte(&H81)

   Call Lcd_select_reg(&Hf7)                                'Pump ratio control
   Call Lcd_write_byte(&H20)

   Call Lcd_select_reg(&Hc0)                                'Power control
   Call Lcd_write_byte(&H23)

   Call Lcd_select_reg(&Hc1)                                'Power control
   Call Lcd_write_byte(&H10)

   Call Lcd_select_reg(&Hc5)                                'VCM control
   Call Lcd_write_byte(&H3e)
   Call Lcd_write_byte(&H28)

   Call Lcd_select_reg(&Hc7)                                'VCOM Control 2
   Call Lcd_write_byte(&H86)

      'Bit 0 = 0
   'Bit 1 = 0
   'Bit 2 = MH Horizontal Refrech order
   'Bit 3 = RGB-BGR Order
   'Bit 4 = ML Vertical Refrech Order
   'Bit 5 = MV Row/Columm Exchange
   'Bit 6 = MX Column Adress Order
   'Bit 7 = MY Row Adress Order
   #if Lcd_mode = 1
      Call Lcd_select_reg(&H36)                             'Memory Access Control
      Call Lcd_write_byte(&B0100_1000)                      '0100-1000
   #elseif Lcd_mode = 2
      Call Lcd_select_reg(&H36)
      Call Lcd_write_byte(&B1000_1000)
   #elseif Lcd_mode = 3
      Call Lcd_select_reg(&H36)
      Call Lcd_write_byte(&B1110_1000)

   #elseif Lcd_mode = 4
      Call Lcd_select_reg(&H36)
      Call Lcd_write_byte(&B0010_1000)
   #endif


   Call Lcd_select_reg(&H3a)                                'COLMOD: Pixel Format Set
   Call Lcd_write_byte(&H55)

   Call Lcd_select_reg(&Hb1)                                'Frame Rate Control (In Normal Mode/Full Colors)
   Call Lcd_write_byte(&H00)
   Call Lcd_write_byte(&H18)

   Call Lcd_select_reg(&Hb6)                                'Display Function Control
   Call Lcd_write_byte(&H08)
   Call Lcd_write_byte(&H82)
   Call Lcd_write_byte(&H27)

   Call Lcd_select_reg(&Hf2)                                '3Gamma Function Disable
   Call Lcd_write_byte(&H00)

   Call Lcd_select_reg(&H26)                                'Gamma curve selected
   Call Lcd_write_byte(&H01)


   Call Lcd_select_reg(&He0)                                'Set Gamma
   Call Lcd_write_byte(&H0f)
   Call Lcd_write_byte(&H31)
   Call Lcd_write_byte(&H2b)
   Call Lcd_write_byte(&H0c)
   Call Lcd_write_byte(&H0e)
   Call Lcd_write_byte(&H08)
   Call Lcd_write_byte(&H4e)
   Call Lcd_write_byte(&Hf1)
   Call Lcd_write_byte(&H37)
   Call Lcd_write_byte(&H07)
   Call Lcd_write_byte(&H10)
   Call Lcd_write_byte(&H03)
   Call Lcd_write_byte(&H0e)
   Call Lcd_write_byte(&H09)
   Call Lcd_write_byte(&H00)

   Call Lcd_select_reg(&He1)                                'Set Gamma
   Call Lcd_write_byte(&H00)
   Call Lcd_write_byte(&H0e)
   Call Lcd_write_byte(&H14)
   Call Lcd_write_byte(&H03)
   Call Lcd_write_byte(&H11)
   Call Lcd_write_byte(&H07)
   Call Lcd_write_byte(&H31)
   Call Lcd_write_byte(&Hc1)
   Call Lcd_write_byte(&H48)
   Call Lcd_write_byte(&H08)
   Call Lcd_write_byte(&H0f)
   Call Lcd_write_byte(&H0c)
   Call Lcd_write_byte(&H31)
   Call Lcd_write_byte(&H36)
   Call Lcd_write_byte(&H0f)


   Call Lcd_select_reg(&H11)                                'Exit Sleep
   Waitms 150
   Call Lcd_select_reg(&H29)                                'normal display on
   Waitms 150

   'ER-TFTM028-3  2.8inch
'(
   Call Lcd_select_reg(&Hcb)                                'Power control A    ILI9341
   Call Lcd_write_byte(&H39)
   Call Lcd_write_byte(&H2c)
   Call Lcd_write_byte(&H00)
   Call Lcd_write_byte(&H34)
   Call Lcd_write_byte(&H02)

   Call Lcd_select_reg(&Hcf)                                'Power control B
   Call Lcd_write_byte(&H00)
   Call Lcd_write_byte(&Hc1)                                '8b
   Call Lcd_write_byte(&H30)

   Call Lcd_select_reg(&He8)                                'Driver timing control A (
   Call Lcd_write_byte(&H85)
   Call Lcd_write_byte(&H00)
   Call Lcd_write_byte(&H78)


   Call Lcd_select_reg(&Hea)                                'Driver timing control B
   Call Lcd_write_byte(&H00)
   Call Lcd_write_byte(&H00)


   Call Lcd_select_reg(&Hed)                                'Power on sequence control
   Call Lcd_write_byte(&H64)
   Call Lcd_write_byte(&H03)
   Call Lcd_write_byte(&H12)
   Call Lcd_write_byte(&H81)

   Call Lcd_select_reg(&Hf7)                                'Pump ratio control
   Call Lcd_write_byte(&H20)

   Call Lcd_select_reg(&Hc0)                                'Power control
   Call Lcd_write_byte(&H22)                                '23

   Call Lcd_select_reg(&Hc1)                                'Power control
   Call Lcd_write_byte(&H11)                                '10

   Call Lcd_select_reg(&Hc5)                                'VCM control
   Call Lcd_write_byte(&H3d)                                '3e
   Call Lcd_write_byte(&H20)                                '28

   Call Lcd_select_reg(&Hc7)                                'VCOM Control 2
   Call Lcd_write_byte(&Haa)                                '86
   #if Lcd_mode = 1
      Call Lcd_select_reg(&H36)                             'Memory Access Control
      Call Lcd_write_byte(&B0100_1000)                      '0100-1000
   #else
      Call Lcd_select_reg(&H36)
      Call Lcd_write_byte(&B1110_1000)
   #endif

   Call Lcd_select_reg(&H3a)                                'COLMOD: Pixel Format Set
   Call Lcd_write_byte(&H55)

   Call Lcd_select_reg(&Hb1)                                'Frame Rate Control (In Normal Mode/Full Colors)
   Call Lcd_write_byte(&H00)
   Call Lcd_write_byte(&H18)

   Call Lcd_select_reg(&Hb6)                                'Display Function Control
   Call Lcd_write_byte(&H08)
   Call Lcd_write_byte(&H82)
   Call Lcd_write_byte(&H27)

   Call Lcd_select_reg(&Hf2)                                '3Gamma Function Disable
   Call Lcd_write_byte(&H00)

   Call Lcd_select_reg(&H26)                                'Gamma curve selected
   Call Lcd_write_byte(&H01)


   Call Lcd_select_reg(&He0)                                'Set Gamma
   Call Lcd_write_byte(&H0f)
   Call Lcd_write_byte(&H31)
   Call Lcd_write_byte(&H2b)
   Call Lcd_write_byte(&H0c)
   Call Lcd_write_byte(&H0e)
   Call Lcd_write_byte(&H08)
   Call Lcd_write_byte(&H4e)
   Call Lcd_write_byte(&Hf1)
   Call Lcd_write_byte(&H37)
   Call Lcd_write_byte(&H07)
   Call Lcd_write_byte(&H10)
   Call Lcd_write_byte(&H03)
   Call Lcd_write_byte(&H0e)
   Call Lcd_write_byte(&H09)
   Call Lcd_write_byte(&H00)

   Call Lcd_select_reg(&He1)                                'Set Gamma
   Call Lcd_write_byte(&H00)
   Call Lcd_write_byte(&H0e)
   Call Lcd_write_byte(&H14)
   Call Lcd_write_byte(&H03)
   Call Lcd_write_byte(&H11)
   Call Lcd_write_byte(&H07)
   Call Lcd_write_byte(&H31)
   Call Lcd_write_byte(&Hc1)
   Call Lcd_write_byte(&H48)
   Call Lcd_write_byte(&H08)
   Call Lcd_write_byte(&H0f)
   Call Lcd_write_byte(&H0c)
   Call Lcd_write_byte(&H31)
   Call Lcd_write_byte(&H36)
   Call Lcd_write_byte(&H0f)



   Call Lcd_select_reg(&H11)                                'Exit Sleep
   Waitms 150
   Call Lcd_select_reg(&H29)                                'normal display on
   Waitms 150
')
End Sub

'-------------------------------------------------------------------------------
' Select an index register
'-------------------------------------------------------------------------------
Sub Lcd_select_reg(byval Index As Byte )
    '  Cs_disp = 0
      Rs_disp = 0
      Data_disp = 0
      Data_disp_low = Index
      Wr_disp = 0
      Wr_disp = 1
    '  Cs_disp = 1
End Sub

Sub Lcd_write_byte(byval Daten As Byte)
   '  Cs_disp = 0
     Rs_disp = 1
     Data_disp = 0
     Data_disp_low = Daten                                  'Low(daten
     Wr_disp = 0
     Wr_disp = 1
   '  Cs_disp = 1
End Sub
'-------------------------------------------------------------------------------
' Write 16 Bit Data to Display
'-------------------------------------------------------------------------------
Sub Lcd_write_data(byval Daten As Word)
     Rgb16 = Daten
   '  Cs_disp = 0
     Rs_disp = 1
     Data_disp = Rgb16_high                                 ' High(daten)
     Data_disp_low = Rgb16_low                              'Low(daten
     Wr_disp = 0
     Wr_disp = 1
   '  Cs_disp = 1
End Sub
'-------------------------------------------------------------------------------
' Write 16 Bit Data to Index Register
'-------------------------------------------------------------------------------
Sub Lcd_write_reg(byval Index As Byte , Daten As Word)
      Rgb16 = Daten

    '  Cs_disp = 0

      Rs_disp = 0
      Data_disp = &H00                                      'VH
      Data_disp_low = Index                                 'VL
      Wr_disp = 0
      Wr_disp = 1
      Rs_disp = 1
      Data_disp = Rgb16_high                                'VH
      Data_disp_low = Rgb16_low                             'VL
      Wr_disp = 0
      Wr_disp = 1

   '   Cs_disp = 1
End Sub